import { DataObject } from "@fluidframework/aqueduct";
import { IFluidHTMLOptions, IFluidHTMLView } from "@fluidframework/view-interfaces";
import * as React from "react";
import { Doc, IArray } from "./types";
export declare class ArrayDataObject<T extends Doc> extends DataObject implements IArray<T>, IFluidHTMLView {
    get state(): T[];
    log(): void;
    get IFluidHTMLView(): this;
    private _store;
    private _map;
    private _elm;
    protected initializingFirstTime(): Promise<void>;
    protected hasInitialized(): Promise<void>;
    render(elm?: HTMLElement, options?: IFluidHTMLOptions): void;
    insert(index: number, content: T): T[];
    push(content: T): number;
    unshift(content: T): number;
    delete(index: number, length?: number): T[];
    get(index: number): T;
    set(index: number, content: T): number;
    clear(): void;
    get length(): number;
}
interface IProps {
    dataObject: ArrayDataObject<any>;
}
export declare const UI: React.FC<IProps>;
export {};
//# sourceMappingURL=ArrayDataObject.d.ts.map