/// <reference types="node" />
import EventEmitter from "events";
export declare type Doc = string | number | boolean | Doc[];
export interface IArray<T> extends EventEmitter {
    readonly state: T[];
    insert(index: number, content: T): T[];
    push(content: T): number;
    unshift(content: T): number;
    delete(index: number, length?: number): T[];
    get(index: number): T;
    set(index: number, content: T): number;
    clear(): void;
    length: number;
    on(event: "arrayModified", listener: () => void): this;
}
//# sourceMappingURL=types.d.ts.map